#!/bin/bash
echo "Run CAP"
# baseline
CUDA_VISIBLE_DEVICES=0 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501 &
CUDA_VISIBLE_DEVICES=1 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc &
CUDA_VISIBLE_DEVICES=2 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17 TEST.DO_VAL True &
# all tasks
# market
CUDA_VISIBLE_DEVICES=0 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_base_1.0identity5_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=1 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_base_1.0identity5_weighted_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=2 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_base_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=3 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_base_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
CUDA_VISIBLE_DEVICES=4 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_hg_1.0identity5_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=5 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_hg_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=6 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_hg_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=7 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_hg_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
CUDA_VISIBLE_DEVICES=7 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/market1501_hg_1.0identity5_weighted_1.0camera0_10.0instance_smoothaploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
# dukemtmc
CUDA_VISIBLE_DEVICES=0 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_base_1.0identity5_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=1 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_base_1.0identity5_weighted_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=2 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_base_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=3 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_base_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
CUDA_VISIBLE_DEVICES=4 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_hg_1.0identity5_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=5 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_hg_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=6 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_hg_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=7 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/DukeMTMC/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/dukemtmc_hg_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
# msmt
CUDA_VISIBLE_DEVICES=0 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_base_1.0identity5_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=1 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_base_1.0identity5_weighted_1.0camera0 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=2 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_base_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=3 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_base_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &
CUDA_VISIBLE_DEVICES=4 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_hg_1.0identity5_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED False CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=5 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_hg_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=6 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_hg_1.0identity5_weighted_1.0camera0_10.0instance_aploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 &
CUDA_VISIBLE_DEVICES=7 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/MSMT17/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50/msmt17_hg_1.0identity5_weighted_1.0camera0_100.0instance_smoothaploss5 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 100.0 CAP.LOSS_INSTANCE.START_EPOCH 5 CAP.LOSS_INSTANCE.NAME "smoothaploss" CAP.LOSS_INSTANCE.LIST_LENGTH 1000 &

# ablation study for hypergraph
CUDA_VISIBLE_DEVICES=0 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50_ablation/market1501_simple_hg_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 PSEUDO.HG.LP.GRAPH "simple" &
CUDA_VISIBLE_DEVICES=1 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50_ablation/market1501_hg_knn_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 PSEUDO.HG.WITH_CLUSTER False PSEUDO.HG.WITH_CAMERA_CLUSTER False &
CUDA_VISIBLE_DEVICES=2 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50_ablation/market1501_hg_knn_camera_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 PSEUDO.HG.WITH_CLUSTER False PSEUDO.HG.WITH_CAMERA_CLUSTER True &
CUDA_VISIBLE_DEVICES=3 python projects/CAP/train_net.py --num-gpus 1 --config-file projects/CAP/configs/Market1501/BoT_R50.yml OUTPUT_DIR logs/CAP/BoT_R50_ablation/market1501_hg_knn_cluster_1.0identity5_weighted_1.0camera0 PSEUDO.NAME "dbscan_hg_lp" CAP.LOSS_IDENTITY.SCALE 1.0 CAP.LOSS_IDENTITY.START_EPOCH 5 CAP.LOSS_CAMERA.SCALE 1.0 CAP.LOSS_CAMERA.START_EPOCH 0 CAP.LOSS_CAMERA.WEIGHTED True CAP.LOSS_INSTANCE.SCALE 10.0 CAP.LOSS_INSTANCE.START_EPOCH 100 CAP.LOSS_INSTANCE.NAME "aploss" CAP.LOSS_INSTANCE.LIST_LENGTH 100 PSEUDO.HG.WITH_CLUSTER True PSEUDO.HG.WITH_CAMERA_CLUSTER False &
